Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/cmdparameters/TXMResultParametersView.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/cmdparameters/TXMResultParametersView.java	(revision 0)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/cmdparameters/TXMResultParametersView.java	(revision 3022)
@@ -0,0 +1,708 @@
+// Copyright © 2010-2020 ENS de Lyon., University of Franche-Comté
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate:$
+// $LastChangedRevision:$
+// $LastChangedBy:$ 
+//
+package org.txm.rcp.views.cmdparameters;
+
+import java.io.File;
+import java.lang.reflect.Field;
+import java.lang.reflect.TypeVariable;
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.Comparator;
+import java.util.List;
+
+import org.eclipse.jface.layout.GridDataFactory;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.custom.ScrolledComposite;
+import org.eclipse.swt.events.SelectionEvent;
+import org.eclipse.swt.events.SelectionListener;
+import org.eclipse.swt.layout.GridData;
+import org.eclipse.swt.layout.GridLayout;
+import org.eclipse.swt.widgets.Button;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Control;
+import org.eclipse.swt.widgets.DirectoryDialog;
+import org.eclipse.swt.widgets.FileDialog;
+import org.eclipse.swt.widgets.Label;
+import org.eclipse.swt.widgets.Spinner;
+import org.eclipse.swt.widgets.Text;
+import org.eclipse.ui.IPartListener;
+import org.eclipse.ui.IPartService;
+import org.eclipse.ui.IPropertyListener;
+import org.eclipse.ui.IWorkbenchPart;
+import org.eclipse.ui.PlatformUI;
+import org.eclipse.ui.part.EditorPart;
+import org.eclipse.ui.part.ViewPart;
+import org.txm.core.results.Parameter;
+import org.txm.core.results.TXMResult;
+import org.txm.rcp.IImageKeys;
+import org.txm.rcp.editors.TXMEditor;
+import org.txm.rcp.swt.widget.PropertiesSelector;
+import org.txm.rcp.swt.widget.QueryWidget;
+import org.txm.rcp.swt.widget.ReferencePatternSelector;
+import org.txm.searchengine.core.IQuery;
+import org.txm.searchengine.cqp.ReferencePattern;
+import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
+import org.txm.searchengine.cqp.corpus.CQPCorpus;
+import org.txm.searchengine.cqp.corpus.Property;
+import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
+import org.txm.searchengine.cqp.corpus.WordProperty;
+
+/**
+ * Alternative display of the TXMEditor form fields
+ * 
+ * @author mdecorde.
+ */
+public class TXMResultParametersView extends ViewPart implements IPartListener, IPropertyListener {
+	
+	/** The ID. */
+	public static String ID = TXMResultParametersView.class.getName(); // $NON-NLS-1$
+	
+	/**
+	 * Instantiates a new queries view.
+	 */
+	public TXMResultParametersView() {
+		
+		IPartService service = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getPartService();
+		service.addPartListener(this);
+	}
+	
+	@Override
+	public void dispose() {
+		
+		IPartService service = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getPartService();
+		service.removePartListener(this);
+	}
+	
+	/**
+	 * Refresh.
+	 */
+	public static void refresh() {
+		
+	}
+	
+	TXMEditor<? extends TXMResult> activated;
+	
+	private Composite panel;
+	
+	private ScrolledComposite scrollC;
+	
+	private Button recompute;
+	
+	public void updateEditorParameters() throws Exception {
+		
+		EditorPart editor = activated;
+		
+		for (Control c : panel.getChildren()) {
+			c.dispose();
+		}
+		
+		if (editor == null) {
+			new Label(panel, SWT.NONE).setText("No editor selected.");
+			recompute.setEnabled(false);
+			return;
+		}
+		
+		if (!(editor instanceof TXMEditor)) {
+			new Label(panel, SWT.NONE).setText("Editor is not a TXMPartEditor: " + editor);
+			return;
+		}
+		recompute.setEnabled(true);
+		TXMEditor reditor = (TXMEditor) editor;
+		final TXMResult result = reditor.getResult();
+		
+		List<Field> allfields = result.getAllFields();
+		List<Field> fields = new ArrayList<>();
+		for (Field f : allfields) {
+			Parameter parameter = f.getAnnotation(Parameter.class);
+			if (parameter == null) {
+				continue;
+			}
+			fields.add(f);
+		}
+		
+		Collections.sort(fields, new Comparator<Field>() {
+			
+			@Override
+			public int compare(Field o1, Field o2) {
+				
+				Parameter parameter1 = o1.getAnnotation(Parameter.class);
+				Parameter parameter2 = o2.getAnnotation(Parameter.class);
+				
+				if (parameter1.type() == parameter2.type()) {
+					return o1.getName().compareTo(o2.getName());
+				}
+				else {
+					return parameter1.type() - parameter2.type();
+				}
+			}
+		});
+		
+		for (final Field f : fields) {
+			Parameter parameter = f.getAnnotation(Parameter.class);
+			if (parameter == null) {
+				continue;
+			}
+			
+			String name;
+			if (!parameter.key().isEmpty()) {
+				name = parameter.key();
+			}
+			else {
+				name = f.getName();
+			}
+			Class<?> clazz = f.getType();
+			f.setAccessible(true);
+			final Object value = f.get(result);
+			
+			new Label(panel, SWT.NONE).setText(name);
+			clazz.equals(Integer.class);
+			Control c = null;
+			if (clazz.equals(Integer.class)) {
+				final Spinner sp = new Spinner(panel, SWT.BORDER);
+				if (value != null) {
+					sp.setSelection((Integer) value);
+				}
+				sp.addSelectionListener(new SelectionListener() {
+					
+					@Override
+					public void widgetSelected(SelectionEvent e) {
+						
+						try {
+							f.set(result, sp.getSelection());
+							if (activated != null && !activated.getParametersGroupsComposite().isDisposed()) {
+								activated.compute(false);
+							}
+						}
+						catch (Exception e1) {
+							// TODO Auto-generated catch block
+							e1.printStackTrace();
+						}
+					}
+					
+					@Override
+					public void widgetDefaultSelected(SelectionEvent e) {}
+				});
+				c = sp;
+			}
+			else if (clazz.equals(String.class)) {
+				final Text t = new Text(panel, SWT.BORDER);
+				if (value != null) {
+					t.setText(value.toString());
+				}
+				t.addKeyListener(new org.eclipse.swt.events.KeyListener() {
+					
+					@Override
+					public void keyReleased(org.eclipse.swt.events.KeyEvent e) {
+						
+						try {
+							f.set(result, t.getText());
+							if (activated != null && !activated.getParametersGroupsComposite().isDisposed()) {
+								activated.compute(false);
+							}
+						}
+						catch (Exception e1) {
+							// TODO Auto-generated catch block
+							e1.printStackTrace();
+						}
+					}
+					
+					@Override
+					public void keyPressed(org.eclipse.swt.events.KeyEvent e) {
+						// TODO Auto-generated method stub
+						
+					}
+				});
+				c = t;
+			}
+			else if (clazz.equals(Float.class)) {
+				final Spinner sp = new Spinner(panel, SWT.BORDER);
+				sp.setSelection((int) ((Float) value * 2));
+				sp.addSelectionListener(new SelectionListener() {
+					
+					@Override
+					public void widgetSelected(SelectionEvent e) {
+						
+						try {
+							f.set(result, sp.getSelection());
+							if (activated != null && !activated.getParametersGroupsComposite().isDisposed()) {
+								activated.compute(false);
+							}
+						}
+						catch (Exception e1) {
+							e1.printStackTrace();
+						}
+					}
+					
+					@Override
+					public void widgetDefaultSelected(SelectionEvent e) {}
+				});
+				c = sp;
+				((Spinner) c).setDigits(2);
+			}
+			else if (clazz.equals(Boolean.class)) {
+				final Button sp = new Button(panel, SWT.CHECK);
+				sp.addSelectionListener(new SelectionListener() {
+					
+					@Override
+					public void widgetSelected(SelectionEvent e) {
+						
+						try {
+							f.set(result, sp.getSelection());
+							if (activated != null && !activated.getParametersGroupsComposite().isDisposed()) {
+								activated.compute(false);
+							}
+						}
+						catch (Exception e1) {
+							e1.printStackTrace();
+						}
+					}
+					
+					@Override
+					public void widgetDefaultSelected(SelectionEvent e) {}
+				});
+				c = sp;
+			}
+			else if (clazz.equals(IQuery.class)) {
+				final QueryWidget qw = new QueryWidget(panel, SWT.NONE);
+				if (value != null) {
+					qw.setText(((IQuery) value).getQueryString());
+				}
+				qw.addSelectionListener(new SelectionListener() {
+					
+					@Override
+					public void widgetSelected(SelectionEvent e) {
+						
+						try {
+							f.set(result, qw.getQuery());
+							if (activated != null && !activated.getParametersGroupsComposite().isDisposed()) {
+								activated.compute(false);
+							}
+						}
+						catch (Exception e1) {
+							// TODO Auto-generated catch block
+							e1.printStackTrace();
+						}
+					}
+					
+					@Override
+					public void widgetDefaultSelected(SelectionEvent e) {}
+				});
+				qw.addKeyListener(new org.eclipse.swt.events.KeyListener() {
+					
+					@Override
+					public void keyReleased(org.eclipse.swt.events.KeyEvent e) {
+						
+						if (e.keyCode != SWT.KEYPAD_CR && e.keyCode != SWT.CR) {
+							return;
+						}
+						try {
+							f.set(result, qw.getQuery());
+							if (activated != null && !activated.getParametersGroupsComposite().isDisposed()) {
+								activated.compute(false);
+							}
+						}
+						catch (Exception e1) {
+							// TODO Auto-generated catch block
+							e1.printStackTrace();
+						}
+					}
+					
+					@Override
+					public void keyPressed(org.eclipse.swt.events.KeyEvent e) {}
+				});
+				c = qw;
+			}
+			else if (clazz.equals(File.class)) {
+				final Button b = new Button(panel, SWT.PUSH);
+				if (value != null) {
+					b.setText(value.toString());
+					
+				}
+				
+				b.addSelectionListener(new SelectionListener() {
+					
+					@Override
+					public void widgetSelected(SelectionEvent e) {
+						
+						File file = (File) value;
+						if (file.isDirectory()) {
+							DirectoryDialog dialog = new DirectoryDialog(panel.getDisplay().getActiveShell());
+							dialog.setText("Choose directory");
+							dialog.setFilterPath(file.getAbsolutePath());
+							String path = dialog.open();
+							if (path != null) {
+								try {
+									f.set(result, path);
+									b.setText(path);
+									if (activated != null && !activated.getParametersGroupsComposite().isDisposed()) {
+										activated.compute(false);
+									}
+								}
+								catch (IllegalArgumentException e1) {
+									// TODO Auto-generated catch block
+									e1.printStackTrace();
+								}
+								catch (IllegalAccessException e1) {
+									// TODO Auto-generated catch block
+									e1.printStackTrace();
+								}
+							}
+						}
+						else {
+							FileDialog dialog = new FileDialog(panel.getDisplay().getActiveShell());
+							dialog.setText("Choose directory");
+							dialog.setFilterPath(file.getAbsolutePath());
+							String path = dialog.open();
+							if (path != null) {
+								try {
+									f.set(result, path);
+									b.setText(path);
+									if (activated != null && !activated.getParametersGroupsComposite().isDisposed()) {
+										activated.compute(false);
+									}
+								}
+								catch (IllegalArgumentException e1) {
+									// TODO Auto-generated catch block
+									e1.printStackTrace();
+								}
+								catch (IllegalAccessException e1) {
+									// TODO Auto-generated catch block
+									e1.printStackTrace();
+								}
+							}
+						}
+					}
+					
+					@Override
+					public void widgetDefaultSelected(SelectionEvent e) {}
+				});
+			}
+			else if (clazz.equals(List.class)) {
+				List list = (List) value;
+				if (list.isEmpty()) {
+					Label l3 = new Label(panel, SWT.NONE);
+					l3.setText("no value");
+					c = l3;
+				}
+				else {
+					Object first = list.get(0);
+					if (first instanceof WordProperty) {
+						c = createWordPropertyField(f, result, list);
+					}
+					else if (first instanceof StructuralUnitProperty) {
+						c = createStructuralUnitPropertyField(f, result, list);
+					}
+				}
+				// } else if (value instanceof StructuralUnit) {
+			}
+			else if (clazz.equals(WordProperty.class)) {
+				ArrayList<WordProperty> selected = new ArrayList<>();
+				selected.add((WordProperty) value);
+				c = createWordPropertyField(f, result, selected);
+				// } else if (value instanceof StructuralUnit) {
+				// Label l2 = new Label(panel,
+				// SWT.NONE).setText("="+value.toString());
+			}
+			else if (clazz.equals(StructuralUnitProperty.class)) {
+				ArrayList<StructuralUnitProperty> selected = new ArrayList<>();
+				selected.add((StructuralUnitProperty) value);
+				c = createStructuralUnitPropertyField(f, result, selected);
+				// } else if (value instanceof ReferencePattern) {
+				// c = new Label(panel, SWT.NONE).setText("="+value.toString());
+			}
+			else if (clazz.equals(ReferencePattern.class)) {
+				c = createReferencePatternField(f, result, (ReferencePattern) value);
+				// } else if (value instanceof ReferencePattern) {
+				// c = new Label(panel, SWT.NONE).setText("="+value.toString());
+			}
+			else {
+				Label l2 = new Label(panel, SWT.NONE);
+				if (value != null) {
+					TypeVariable<?>[] pp = value.getClass().getTypeParameters();
+					l2.setText(clazz.getSimpleName() + "=" + value);
+				}
+				else {
+					l2.setText(clazz.getSimpleName() + "=" + value);
+				}
+				c = l2;
+			}
+			
+			if (c != null) {
+				c.setLayoutData(GridDataFactory.fillDefaults().grab(true, false).create());
+			}
+		}
+		scrollC.setContent(panel);
+		scrollC.setMinSize(panel.computeSize(SWT.DEFAULT, SWT.DEFAULT));
+		scrollC.setExpandHorizontal(true);
+		scrollC.setExpandVertical(true);
+		scrollC.layout(true);
+	}
+	
+	private Control createReferencePatternField(final Field f, final TXMResult result, ReferencePattern value) throws Exception {
+		
+		final List<Property> selected = new ArrayList<>();
+		selected.addAll(value.getProperties());
+		CQPCorpus corpus = value.getCorpus();
+		ReferencePatternSelector selector = new ReferencePatternSelector(panel, SWT.NONE);
+		if (corpus != null) {
+			List<Property> availables = new ArrayList<>();
+			availables.addAll(corpus.getOrderedProperties());
+			availables.addAll(corpus.getOrderedStructuralUnitProperties());
+			availables.removeAll(selected);
+			selector.setPattern(value.getPattern());
+			selector.setProperties(availables, selected);
+		}
+		selector.addSelectionListener(new SelectionListener() {
+			
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				
+				if (activated != null && !activated.getParametersGroupsComposite().isDisposed()) {
+					ReferencePattern p = new ReferencePattern(selected);
+					try {
+						f.set(result, p);
+					}
+					catch (IllegalArgumentException e1) {
+						// TODO Auto-generated catch block
+						e1.printStackTrace();
+					}
+					catch (IllegalAccessException e1) {
+						// TODO Auto-generated catch block
+						e1.printStackTrace();
+					}
+					activated.compute(false);
+				}
+			}
+			
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {}
+		});
+		// selector.setLayoutData(layoutData);
+		return selector;
+	}
+	
+	protected PropertiesSelector<WordProperty> createWordPropertyField(final Field f, final TXMResult result, final List<WordProperty> selected) throws CqiClientException {
+		
+		WordProperty value = selected.get(0);
+		CQPCorpus corpus = value.getCorpus();
+		
+		ArrayList<WordProperty> availables = new ArrayList<>(corpus.getOrderedProperties());
+		availables.addAll(corpus.getVirtualProperties());
+		availables.remove(value);
+		
+		PropertiesSelector<WordProperty> selector = new PropertiesSelector<>(panel, SWT.NONE);
+		selector.setProperties(availables, selected);
+		selector.addSelectionListener(new SelectionListener() {
+			
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				
+				if (activated != null && !activated.getParametersGroupsComposite().isDisposed()) {
+					try {
+						f.set(result, selected);
+					}
+					catch (Exception e1) {
+						// TODO Auto-generated catch block
+						e1.printStackTrace();
+					}
+					activated.compute(false);
+				}
+			}
+			
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {}
+		});
+		// selector.setLayoutData(layoutData);
+		return selector;
+	}
+	
+	private PropertiesSelector<StructuralUnitProperty> createStructuralUnitPropertyField(final Field f, final TXMResult result, final List<StructuralUnitProperty> selected) throws CqiClientException {
+		
+		StructuralUnitProperty value = selected.get(0);
+		CQPCorpus corpus = value.getCorpus();
+		ArrayList<StructuralUnitProperty> availables = new ArrayList<>();
+		availables.addAll(corpus.getOrderedStructuralUnitProperties());
+		availables.remove(value);
+		PropertiesSelector<StructuralUnitProperty> selector = new PropertiesSelector<>(panel, SWT.NONE);
+		selector.setProperties(availables, selected);
+		selector.addSelectionListener(new SelectionListener() {
+			
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				
+				if (activated != null && !activated.getParametersGroupsComposite().isDisposed()) {
+					try {
+						f.set(result, selected);
+					}
+					catch (Exception e1) {
+						// TODO Auto-generated catch block
+						e1.printStackTrace();
+					}
+					activated.compute(false);
+				}
+			}
+			
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {}
+		});
+		return selector;
+	}
+	
+	/*
+	 * (non-Javadoc)
+	 * @see
+	 * org.eclipse.ui.part.WorkbenchPart#createPartControl(org.eclipse.swt.widgets
+	 * .Composite)
+	 */
+	@Override
+	public void createPartControl(Composite parent) {
+		
+		parent.setLayout(new GridLayout(1, true));
+		
+		recompute = new Button(parent, SWT.PUSH);
+		recompute.setImage(IImageKeys.getImage(IImageKeys.START));
+		recompute.addSelectionListener(new SelectionListener() {
+			
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				
+				if (activated != null && !activated.getParametersGroupsComposite().isDisposed()) {
+					activated.compute(false);
+				}
+			}
+			
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {}
+		});
+		recompute.setLayoutData(GridDataFactory.fillDefaults().align(GridData.BEGINNING, GridData.BEGINNING).grab(false, false).create());
+		recompute.setEnabled(false);
+		
+		scrollC = new ScrolledComposite(parent, SWT.H_SCROLL | SWT.V_SCROLL);
+		scrollC.setLayoutData(GridDataFactory.fillDefaults().grab(true, true).create());
+		
+		panel = new Composite(scrollC, SWT.NONE);
+		panel.setLayout(new GridLayout(2, true));
+		
+		try {
+			updateEditorParameters();
+		}
+		catch (Exception e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+	
+	@Override
+	public void partActivated(IWorkbenchPart part) {
+		
+		if (part == null)
+			return;
+		// System.out.println("partActivated: "+part);
+		if (part instanceof TXMEditor)
+			activated = (TXMEditor) part;
+		if (activated == null)
+			return;
+		activated.addPropertyListener(this);
+		recompute.setEnabled(true);
+		// activated.addPartPropertyListener(this);
+		try {
+			updateEditorParameters();
+		}
+		catch (Exception e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+	
+	@Override
+	public void partBroughtToTop(IWorkbenchPart part) {
+		
+		if (part == null)
+			return;
+	}
+	
+	@Override
+	public void partClosed(IWorkbenchPart part) {
+		
+		if (part == null)
+			return;
+		if (part == activated) {
+			activated = null;
+			try {
+				updateEditorParameters();
+			}
+			catch (Exception e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+		}
+	}
+	
+	@Override
+	public void partDeactivated(IWorkbenchPart part) {
+		
+		if (part == null)
+			return;
+		// System.out.println("partDeactivated: "+part);
+		// if (part instanceof TXMEditor)
+		// activated = null;
+		// try {
+		// updateEditorParameters();
+		// } catch (Exception e) {
+		// // TODO Auto-generated catch block
+		// e.printStackTrace();
+		// }
+	}
+	
+	@Override
+	public void propertyChanged(Object source, int propId) {
+		
+		// System.out.println("Editor property changed: "+propId);
+		if (propId == EditorPart.PROP_DIRTY) {
+			try {
+				updateEditorParameters();
+			}
+			catch (Exception e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+		}
+	}
+	
+	@Override
+	public void partOpened(IWorkbenchPart part) {
+		
+		if (part == null)
+			return;
+	}
+	
+	@Override
+	public void setFocus() {
+		// TODO Auto-generated method stub
+	}
+}

Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/cmdparameters/TXMResultParametersComposite.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/cmdparameters/TXMResultParametersComposite.java	(revision 0)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/cmdparameters/TXMResultParametersComposite.java	(revision 3022)
@@ -0,0 +1,265 @@
+package org.txm.rcp.views.cmdparameters;
+
+import java.util.ArrayList;
+import java.util.Arrays;
+
+import org.apache.commons.lang.StringUtils;
+import org.eclipse.core.resources.IProject;
+import org.eclipse.core.runtime.preferences.IEclipsePreferences;
+import org.eclipse.jface.layout.GridDataFactory;
+import org.eclipse.jface.viewers.CellLabelProvider;
+import org.eclipse.jface.viewers.EditingSupport;
+import org.eclipse.jface.viewers.ITreeContentProvider;
+import org.eclipse.jface.viewers.TextCellEditor;
+import org.eclipse.jface.viewers.TreeViewer;
+import org.eclipse.jface.viewers.TreeViewerColumn;
+import org.eclipse.jface.viewers.ViewerCell;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.layout.GridData;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Text;
+import org.osgi.service.prefs.BackingStoreException;
+import org.osgi.service.prefs.Preferences;
+import org.txm.core.preferences.TXMPreferences;
+import org.txm.core.results.TXMResult;
+import org.txm.objects.Project;
+import org.txm.rcp.IImageKeys;
+import org.txm.rcp.preferences.RCPPreferences;
+import org.txm.rcp.swt.GLComposite;
+
+public class TXMResultParametersComposite extends GLComposite {
+	
+	private TreeViewer tv;
+	
+	private TreeViewerColumn nameColumn;
+	
+	private TreeViewerColumn valueColumn;
+	
+	private TextCellEditor cellEditor;
+	
+	public static String DEFAULT_REFS = "class,user_name";
+	
+	private String[] references = DEFAULT_REFS.split(",");
+	
+	public TXMResultParametersComposite(Composite parent, int style) {
+		super(parent, style, "Parameters");
+		
+		tv = new TreeViewer(this, SWT.VIRTUAL);
+		tv.getTree().setLayoutData(GridDataFactory.fillDefaults().align(GridData.FILL, GridData.FILL).grab(true, true).create());
+		tv.getTree().setHeaderVisible(true);
+		tv.getTree().setLinesVisible(true);
+		tv.setContentProvider(new ITreeContentProvider() {
+			
+			@Override
+			public Object[] getElements(Object inputElement) {
+				if (inputElement instanceof String) {
+					String npath = inputElement.toString();
+					Object[] children = getChildren(TXMPreferences.preferencesRootNode.node(npath));
+					return children;
+				}
+				else if (inputElement instanceof Project) {
+					Project project = (Project) inputElement;
+					IEclipsePreferences prefs = project.getPreferencesScope().getNode("/project/" + project.getName());
+					return getChildren(prefs);
+				}
+				else if (inputElement instanceof TXMResult) {
+					TXMResult result = (TXMResult) inputElement;
+					// return new Object[] {TXMPreferences.preferencesRootNode.node(result.getParametersNodePath())};
+					return getChildren(TXMPreferences.preferencesRootNode.node(result.getParametersNodePath()));
+				}
+				else if (inputElement instanceof IProject) {
+					IProject project = (IProject) inputElement;
+					return getChildren(TXMPreferences.preferencesRootNode.node("/" + project.getName()));
+				}
+				
+				return new Object[0];
+			}
+			
+			@Override
+			public Object[] getChildren(Object parentElement) {
+				if (parentElement instanceof Preferences) {
+					Preferences prefs = (Preferences) parentElement;
+					try {
+						ArrayList<Object> children = new ArrayList<>();
+						String[] nodes = prefs.childrenNames();
+						Arrays.sort(nodes);
+						for (String n : nodes) {
+							children.add(prefs.node(n));
+						}
+						
+						String[] attributes = null;
+						// FIXME: SJ => MD, I commented this atm
+						// if (RCPPreferences.getInstance().getBoolean(RCPPreferences.EXPERT_USER)) {
+						//
+						// } else {
+						attributes = prefs.keys();
+						// }
+						Arrays.sort(attributes);
+						for (String name : attributes) {
+							children.add(new Object[] { prefs, name });
+						}
+						return children.toArray();
+					}
+					catch (BackingStoreException e) {
+						e.printStackTrace();
+					}
+				}
+				return null;
+			}
+			
+			@Override
+			public Object getParent(Object element) {
+				if (element instanceof Preferences) {
+					Preferences prefs = (Preferences) element;
+					return prefs.parent();
+				}
+				return null;
+			}
+			
+			@Override
+			public boolean hasChildren(Object element) {
+				if (element instanceof Preferences) {
+					Preferences prefs = (Preferences) element;
+					try {
+						return prefs.childrenNames().length > 0 || prefs.keys().length > 0;
+					}
+					catch (BackingStoreException e) {
+						// TODO Auto-generated catch block
+						e.printStackTrace();
+					}
+				}
+				return false;
+			}
+			
+		});
+		
+		nameColumn = new TreeViewerColumn(tv, SWT.NONE);
+		nameColumn.getColumn().setText("node");
+		nameColumn.getColumn().pack();
+		nameColumn.setLabelProvider(new CellLabelProvider() {
+			
+			@Override
+			public void update(ViewerCell cell) {
+				Object element = cell.getElement();
+				
+				if (element instanceof Preferences) {
+					Preferences c = (Preferences) element;
+					if (references != null && references.length > 0) {
+						ArrayList<String> values = new ArrayList<>();
+						for (String k : references) {
+							if (c.get(k, null) != null) {
+								values.add(c.get(k, null));
+							}
+						}
+						
+						if (values.size() == 0) values.add(c.name());
+						cell.setText(StringUtils.join(values, ", "));
+					}
+					else {
+						cell.setText(c.name());
+					}
+					
+					if (c.get("class", null) != null && c.get("class", null).startsWith("org.txm")) {
+						cell.setImage(IImageKeys.getImage(IImageKeys.PROJECT));
+					}
+				}
+				else if (element instanceof Object[]) {
+					Object[] c = (Object[]) element;
+					
+					cell.setText(c[1].toString());
+				}
+				else {
+					cell.setText(element.toString());
+				}
+			}
+			
+		});
+		valueColumn = new TreeViewerColumn(tv, SWT.NONE);
+		valueColumn.getColumn().setText("value");
+		valueColumn.getColumn().pack();
+		valueColumn.setLabelProvider(new CellLabelProvider() {
+			
+			@Override
+			public void update(ViewerCell cell) {
+				Object element = cell.getElement();
+				
+				if (element instanceof Preferences) {
+					Preferences c = (Preferences) element;
+					cell.setText("");
+				}
+				else if (element instanceof Object[]) {
+					Object[] c = (Object[]) element;
+					Preferences p = (Preferences) c[0];
+					cell.setText(p.get(c[1].toString(), ""));
+				}
+				else {
+					cell.setText(element.toString());
+				}
+			}
+		});
+		
+		cellEditor = new TextCellEditor(tv.getTree());
+		valueColumn.setEditingSupport(new EditingSupport(tv) {
+			
+			@Override
+			protected void setValue(Object element, Object value) {
+				if (element instanceof Object[]) {
+					Object[] data = (Object[]) element;
+					Preferences prefs = (Preferences) data[0];
+					String key = data[1].toString();
+					prefs.put(key, value.toString());
+					tv.refresh(element);
+					
+				}
+				return;
+			}
+			
+			@Override
+			protected Object getValue(Object element) {
+				if (element instanceof Object[]) {
+					Object[] data = (Object[]) element;
+					Preferences prefs = (Preferences) data[0];
+					String key = data[1].toString();
+					return prefs.get(key, "");
+				}
+				return null;
+			}
+			
+			@Override
+			protected TextCellEditor getCellEditor(Object element) {
+				return cellEditor;
+			}
+			
+			@Override
+			protected boolean canEdit(Object element) {
+				return element instanceof Object[];
+			}
+		});
+	}
+	
+	
+	
+	public void updateEditorParameters(Object input) {
+		tv.setInput(input);
+		nameColumn.getColumn().pack();
+		valueColumn.getColumn().pack();
+	}
+	
+	
+	
+	public void refresh() {
+		tv.refresh();
+	}
+	
+	public void setReferences(String[] split) {
+		references = split;
+	}
+	
+	public TreeViewer getTreeViewer() {
+		return tv;
+	}
+	
+	public Object getInput() {
+		return tv.getInput();
+	}
+}

